! Efficient relaxation of atoms (GLOC)
! Citation of the following papers is mandatory:
!  E. Bitzek, D. Weygand and P. Gumbsch
!   IUTAM Symposium on Mesoscopic Dynamics of Fracture Process and Material Strength
!   ed. H. Kitagawa and Y. Shibutani, Kluwer Academic Publishers, Dordrecht
!   pp.45-57 (2004)
!  J. H. A. Hagellar, E. Bitzek, D. F. J. Flipse and P. Gumbsch
!   Phys. Rev. B 73 art.no. 045425 (2006)
!
!      subroutine atom_damping(na,vx,vy,vz,fx,fy,fz,istep,iint)
subroutine atom_damping(iint)
  use variables
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
!      dimension fx(na),fy(na),fz(na)
!      dimension vx(na),vy(na),vz(na)
      double precision :: sp

! 'Whole atoms' damping (should be more efficient than below)
      if (iint<1) return
      if (mod(istep,iint)==0) then
         sp=0.0d0
         do i=1,na
            sp = sp+fx(i)*vx(i)+fy(i)*vy(i)+fz(i)*vz(i)
         enddo
         if (sp < 0.0) then
            vx=0.0d0; vy=0.0d0; vz=0.0d0
         endif
      endif

! 'Each atom' damping (less efficient)
!      do i=1,n
!         sp = fx(i)*vx(i)+fy(i)*vy(i)+fz(i)*vz(i)
!         if (sp < 0.0) then
!            vx(i)=0.0d0; vy(i)=0.0d0; vz(i)=0.0d0
!         endif
!      enddo

      end
