C  ****************************************************************
C
C       SUBROUTINE CAREPS: CALCULATION OF REPULSIVE ENERGIES
C                          BY WANG METHOD
C  ****************************************************************
      SUBROUTINE CAREPS_old(NA,RPI,ERI,NN,DX,DY,DZ,MAN,FRX,FRY,FRZ,IP)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION RPI(NA),FRX(NA),FRY(NA),FRZ(NA),NN(NA),ERI(NA)
     &         ,DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA)
     &         ,IP(MAN,NA)

c     V(ll'm)դΥѥ᡼
c
      tss=-5.00d0
      tsp=4.70d0
      tpps=5.50d0
      tppp=-1.55d0

      rn=2.0d0
      rnc=6.5d0
      rc=2.18d0
      roo=1.536329d0
      rr1=2.45d0

      rocnc=(roo/rc)**rnc

      rp0=8.18555d0
      rm=3.30304d0
      rmc=8.6655d0
      dc=2.1052d0
      d0=1.64d0
      d1=2.57d0

      docmc=(d0/dc)**rmc
c
      rmax=2.60d0
      RS=rmax

c     coefficients for polynomials
c
      sc0=6.7392620074314d0*10.0d0**(-3)
      sc1=-8.1885359517898d0*10.0d0**(-2)
      sc2=0.1932365259144d0
      sc3=0.3542874332380d0
c
      pc0=2.2504290109d0*10.0d0**(-8)
      pc1=-1.4408640561d0*10.0d0**(-6)
      pc2=2.1043303374d0*10.0d0**(-5)
      pc3=6.6024390226d0*10.0d0**(-5)

      fc0=-2.5909765118191d0
      fc1=0.5721151498619d0
      fc2=-1.7896349903996d0*10.0d0**(-3)
      fc3=2.3539221516757d0*10.0d0**(-5)
      fc4=-1.24251169551587d0*10.0d0**(-7)


c-----ͥ륮η׻
      DO 100 I=1,NA
      ERI(I)=0.0D0
  100 CONTINUE

      DO 110 I=1,NA
         MM=NN(I)
         DO 120 J=1,MM
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)

            REP=RP0*(D0/RR)**RM*DEXP(RM*(-(RR/DC)**RMC+DOCMC))
         IF(RR.GT.D1) REP=PC0+PC1*(RR-D1)+PC2*(RR-D1)**2+PC3*(RR-D1)**3
            ERI(I)=ERI(I)+REP

 120     CONTINUE
         RPI(I)=FC0+FC1*ERI(I)+FC2*ERI(I)**2+FC3*ERI(I)**3+FC4*ERI(I)**4
 110  CONTINUE

c-----Ϥη׻
      DO 101 I=1,NA
      FRX(i)=0.0D0
      FRY(i)=0.0D0
      FRZ(i)=0.0D0
  101 CONTINUE

      DO 111 I=1,NA
         MM=NN(I)
         DO 121 J=1,MM
            K=IP(J,I)
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)
            RLL=DX(J,I)/RR
            RMM=DY(J,I)/RR
            RNN=DZ(J,I)/RR
            REX=RP0*(-RM/RR-RM*RMC/RR*(RR/DC)**RMC)*(D0/RR)**RM*
     &                DEXP(RM*(-(RR/DC)**RMC+DOCMC))
      IF(RR.GT.D1) REX=3.0D0*PC3*(RR-D1)**2+2.0D0*PC2*(RR-D1)+PC1
      FD1=4.0D0*FC4*ERI(I)**3+3.0D0*FC3*ERI(I)**2+2.0D0*FC2*ERI(I)+FC1
      FD2=4.0D0*FC4*ERI(K)**3+3.0D0*FC3*ERI(K)**2+2.0D0*FC2*ERI(K)+FC1
      FF=FD1+FD2
      FRX(I)=FRX(I)+RLL*REX*FF
      FRY(I)=FRY(I)+RMM*REX*FF
      FRZ(I)=FRZ(I)+RNN*REX*FF
C         print *,'ERI(',i,')=',ERI(i)
C         print *,i,j,k,dphix,dphiy,dphiz,ff
C         print *,i,j,k,FRX(i),FRy(i),FRz(i)
 121     CONTINUE
 111  CONTINUE

C      do i=1,na
C      print *,frx(i),fry(i),frz(i)
C      enddo


      RETURN
      END
