C  *****************************************************************    
C                                                                       
C      SUBROUTINE KDIAMOND   K POINT in diamond structure          
C                                                                      
C  ****************************************************************    
      SUBROUTINE kdiamond(NS,XS,YS,ZS,A,ao,pi)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
      DIMENSION XS(NS),YS(NS),ZS(NS),A(NS)                              

      n1=26
      n2=13
      n3=10
      n4=28
      n5=23

c      n1=3
c      n2=1
c      n3=1
c      n4=3
c      n5=2

c     
      XS(1)=0.0D0                                       
      YS(1)=0.0D0                                       
      ZS(1)=0.0D0  
      A(1)=1.0D0/NS 

c     -X 
      DO 10 IZ=1,n1
      XS(iz+1)=0.0D0                                       
      YS(iz+1)=0.0D0                                       
      ZS(iz+1)=2.0d0*pi/ao/(dble(n1)+1.0d0)*dble(iz)
      A(iz+1)=1.0D0/NS
   10 CONTINUE
       
c     X
      XS(n1+2)=0.0D0                                       
      YS(n1+2)=0.0D0                                       
      ZS(n1+2)=2.0d0*pi/ao
      A(n1+2)=1.0D0/NS 

c     X-W 
      DO 20 IZ=1,n2
      XS(iz+n1+2)=pi/ao/(dble(n2)+1.0d0)*dble(iz) 
      YS(iz+n1+2)=0.0d0    
      ZS(iz+n1+2)=2.0d0*pi/ao
      A(iz+n1+2)=1.0D0/NS
   20 CONTINUE

c     W
      XS(n1+n2+3)=pi/ao                                 
      YS(n1+n2+3)=0.0d0                                    
      ZS(n1+n2+3)=2.0d0*pi/ao
      A(n1+n2+3)=1.0D0/NS 

c     W-K 
      DO 30 IZ=1,n3
      XS(iz+n1+n2+3)=pi/ao
     &              +pi/ao/2.0d0/(dble(n3)+1.0d0)*dble(iz)
      YS(iz+n1+n2+3)=0.0d0
      ZS(iz+n1+n2+3)=2.0d0*pi/ao
     &              -pi/ao/2.0d0/(dble(n3)+1.0d0)*dble(iz)
      A(iz+n1+2)=1.0D0/NS
   30 CONTINUE

c     K
      XS(n1+n2+n3+4)=3.0d0/2.0d0*pi/ao                                     
      YS(n1+n2+n3+4)=0.0d0                                 
      ZS(n1+n2+n3+4)=3.0d0/2.0d0*pi/ao    
      A(n1+n2+n3+4)=1.0D0/NS 

c     K- 
      DO 40 IZ=1,n4
      XS(iz+n1+n2+n3+4)=3.0d0*pi/2.0d0/ao
     &                 -3.0d0*pi/2.0d0/ao/(dble(n4)+1.0d0)*dble(iz)
      YS(iz+n1+n2+n3+4)=0.0D0 
      ZS(iz+n1+n2+n3+4)=3.0d0*pi/2.0d0/ao
     &                 -3.0d0*pi/2.0d0/ao/(dble(n4)+1.0d0)*dble(iz) 
      A(iz+n1+n2+n3+4)=1.0D0/NS
 40   CONTINUE

c     
      XS(n1+n2+n3+n4+5)=0.0D0                                       
      YS(n1+n2+n3+n4+5)=0.0D0                                       
      ZS(n1+n2+n3+n4+5)=0.0D0  
      A(n1+n2+n3+n4+5)=1.0D0/NS 

c     -L 
      DO 50 IZ=1,n5
      XS(iz+n1+n2+n3+n4+5)=pi/ao/(dble(n5)+1.0d0)*dble(iz)
      YS(iz+n1+n2+n3+n4+5)=pi/ao/(dble(n5)+1.0d0)*dble(iz)
      ZS(iz+n1+n2+n3+n4+5)=pi/ao/(dble(n5)+1.0d0)*dble(iz)
      A(iz+n1+n2+n3+n4+5)=1.0D0/NS
 50   CONTINUE

c     L
      XS(n1+n2+n3+n4+n5+6)=pi/ao                                    
      YS(n1+n2+n3+n4+n5+6)=pi/ao                                        
      ZS(n1+n2+n3+n4+n5+6)=pi/ao  
      A(n1+n2+n3+n4+n5+6)=1.0D0/NS 


      RETURN                                                           
      END    
