C  *****************************************************************    
C                                                                       
C      SUBROUTINE KDIAMOND   K POINT in diamond structure          
C                                                                      
C  ****************************************************************    
      SUBROUTINE kdiamond2(NS,XS,YS,ZS,Ak,ao,pi)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
      DIMENSION XS(NS),YS(NS),ZS(NS),Ak(NS)                              

      n1=24
      n2=12
      n3=17
      n4=21
      n5=26

      
c     
      XS(1)=0.0D0                                       
      YS(1)=0.0D0                                       
      ZS(1)=0.0D0
      Ak(1)=1.0D0/NS 

c     -X 
      DO 10 IZ=1,n1
      XS(iz+1)=0.0D0                                       
      YS(iz+1)=0.0D0                                       
      ZS(iz+1)=2.0d0*pi/ao/(dble(n1)+1.0d0)*dble(iz)
      Ak(iz+1)=1.0D0/NS
   10 CONTINUE
      
c     X
      XS(n1+2)=0.0D0                                       
      YS(n1+2)=0.0D0                                       
      ZS(n1+2)=2.0d0*pi/ao
      Ak(n1+2)=1.0D0/NS 

c     X-W 
      DO 20 IZ=1,n2
      XS(iz+n1+2)=pi/ao/(dble(n2)+1.0d0)*dble(iz)
      YS(iz+n1+2)=0.0D0                                       
      ZS(iz+n1+2)=2.0d0*pi/ao
      Ak(iz+n1+2)=1.0D0/NS
   20 CONTINUE

c     W
      XS(n1+n2+3)=pi/ao                                     
      YS(n1+n2+3)=0.0D0                                       
      ZS(n1+n2+3)=2.0d0*pi/ao
      Ak(n1+n2+3)=1.0D0/NS 

c     W-L 
      DO 30 IZ=1,n3
      XS(iz+n1+n2+3)=pi/ao
      YS(iz+n1+n2+3)=pi/ao/(dble(n3)+1.0d0)*dble(iz)
      ZS(iz+n1+n2+3)=2.0d0*pi/ao
     &              -pi/ao/(dble(n3)+1.0d0)*dble(iz)
      Ak(iz+n1+n2+3)=1.0D0/NS
   30 CONTINUE

c     L
      XS(n1+n2+n3+4)=pi/ao                                    
      YS(n1+n2+n3+4)=pi/ao                                   
      ZS(n1+n2+n3+4)=pi/ao
      Ak(n1+n2+n3+4)=1.0D0/NS 

c     L- 
      DO 40 IZ=1,n4
      XS(iz+n1+n2+n3+4)=pi/ao 
     &                /(dble(n4)+1.0d0)*(dble(n4)+1.0d0-dble(iz))
      YS(iz+n1+n2+n3+4)=pi/ao 
     &                /(dble(n4)+1.0d0)*(dble(n4)+1.0d0-dble(iz))
      ZS(iz+n1+n2+n3+4)=pi/ao 
     &                /(dble(n4)+1.0d0)*(dble(n4)+1.0d0-dble(iz))
      Ak(iz+n1+n2+n3+4)=1.0D0/NS
 40   CONTINUE

c     
      XS(n1+n2+n3+n4+5)=0.0D0                                       
      YS(n1+n2+n3+n4+5)=0.0D0                                       
      ZS(n1+n2+n3+n4+5)=0.0D0  
      Ak(n1+n2+n3+n4+5)=1.0D0/NS 

c     -K 
      DO 50 IZ=1,n5
      XS(iz+n1+n2+n3+n4+5)=3.0d0/2.0d0*pi/ao/(dble(n5)+1.0d0)*dble(iz)
      YS(iz+n1+n2+n3+n4+5)=3.0d0/2.0d0*pi/ao/(dble(n5)+1.0d0)*dble(iz)
      ZS(iz+n1+n2+n3+n4+5)=0.0d0
      Ak(iz+n1+n2+n3+n4+5)=1.0D0/NS
 50   CONTINUE 
c     K
      XS(n1+n2+n3+n4+n5+6)=3.0d0/2.0d0*pi/ao                                
      YS(n1+n2+n3+n4+n5+6)=3.0d0/2.0d0*pi/ao
      ZS(n1+n2+n3+n4+n5+6)=0.0d0
      Ak(n1+n2+n3+n4+n5+6)=1.0D0/NS 

      RETURN                                                           
      END    
