subroutine readconfig
  use variables
  IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
!  dimension x(na),y(na),z(na),a1(3),a2(3),a3(3)
  character (3) :: fmt
  
  open (2,file='CONFIG')
  

  read (2,*)
  read (2,*)
  read (2,*) na
  ! Assuming unit in ang
  read (2,*) ascale
  read (2,*) a1(1),a1(2),a1(3)
  read (2,*) a2(1),a2(2),a2(3)
  read (2,*) a3(1),a3(2),a3(3)
  do i=1,3
     a1(i)=a1(i)*ascale
     a2(i)=a2(i)*ascale
     a3(i)=a3(i)*ascale
  enddo
!  if (n/=na) then
!     print *,'Number of atoms is wrong.'
!     print *,'In CONFIG:', n
!     print *,'In code:  ', na
!     stop 
!  endif
  ! Assuming cartesian coordinates in ang

  allocate (x(na),y(na),z(na))
  allocate (spc(na))

  read (2,*) fmt

  ishift=0
  do i=1,na
!     read (2,*) x(i),y(i),z(i)
     read (2,*) xx, yy, zz
     if (xx < 0.0) ishift=1
     if (fmt=='abs') then
        x(i)=xx; y(i)=yy; z(i)=zz
     else
        x(i)=a1(1)*xx+a1(2)*yy+a1(3)*zz
        y(i)=a2(1)*xx+a2(2)*yy+a2(3)*zz
        z(i)=a3(1)*xx+a3(2)*yy+a3(3)*zz
     endif
  enddo
  close(2)
  
  ! Convert to Bohr
  do i=1,na
     x(i)=x(i)/0.529177d0
     y(i)=y(i)/0.529177d0
     z(i)=z(i)/0.529177d0
  enddo
  do i=1,3
     a1(i)=a1(i)/0.529177d0
     a2(i)=a2(i)/0.529177d0
     a3(i)=a3(i)/0.529177d0
  enddo
  
!     Shift tube to center of cell
  if (ishift==1) then
  do i=1,na
     x(i)=x(i)+a1(1)/2.0
     y(i)=y(i)+a2(2)/2.0
  enddo
  endif

end subroutine readconfig
